//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: HistoryWindow.cc,v 1.12 2001/03/19 05:33:40 tujikawa Exp $

#include "HistoryWindow.h"
#include "ItemCell_HTTP.h"
#include "ItemCell_FTP.h"

extern ItemManager *item_manager;
extern pthread_mutex_t itemlistlock;
extern PasteWindow *paste_window;

extern AppOption *appoption;
extern ThreadManager *thread_manager;
extern pthread_cond_t itemlistnotempty;
extern ItemCell *console_item;
extern GtkWidget *itemlistwidget;
extern void Set_sensitive__list_not_empty();
extern unsigned int Find_nearest_selected_row(GtkWidget *clist, unsigned int row_current);

// history_windowOKܥ򤪤ȸƤӽФ
static gboolean History_Add(GtkWidget *w, GtkWidget *history_list)
{
  string line;

  //gtk_widget_hide(GTK_WIDGET(gtk_object_get_user_data(GTK_OBJECT(w))));

  if(GTK_CLIST(history_list)->rows == 0) return TRUE;

  pthread_mutex_t *history_lock_ptr = (pthread_mutex_t *)(gtk_object_get_user_data(GTK_OBJECT(history_list)));
  pthread_mutex_lock(history_lock_ptr);

  // add to main download list
  bool flag = false;
  GList *node = GTK_CLIST(history_list)->selection;
  while(node) {
    int rowindex = GPOINTER_TO_UINT(node->data);
    char *url_cstr;
    gtk_clist_get_text(GTK_CLIST(history_list), rowindex, HistoryWindow::COL_URL_H, &url_cstr);
    /*
    URLcontainer urlcon;
    urlcon.Parse_URL(url_cstr);
    ItemCell *itemcell;
    Options& options = console_item->ret_Options_opt();

    if(urlcon.ret_Protocol() == "http:") {
      itemcell = new ItemCell_HTTP(url_cstr, urlcon, options, "created");
    } else if(urlcon.ret_Protocol() == "ftp:") {
      itemcell = new ItemCell_FTP(url_cstr, urlcon, options, "created");
    } else {
      node = g_list_next(node);
      continue;
    }

    Add_new_item_to_downloadlist(itemcell);
    */
    if(paste_window->add_item(url_cstr)) flag = true;
    node = g_list_next(node);
  }
  pthread_mutex_unlock(history_lock_ptr);
  if(flag) paste_window->show();

  return TRUE;
}


// history windowdeleteܥ󤬲줿Ȥν
// CLIST additem_list򤵤Ƥ륢ƥबФ롣
static gboolean History_delete(GtkWidget *w, GtkWidget *history_list)
{
  pthread_mutex_t *history_lock_ptr = (pthread_mutex_t *)(gtk_object_get_user_data(GTK_OBJECT(history_list)));

  pthread_mutex_lock(history_lock_ptr);
  GList *node = GTK_CLIST(history_list)->selection;
  while(node) {
    unsigned int rowindex = GPOINTER_TO_UINT(node->data);
    time_t *time_ptr = (time_t *)gtk_clist_get_row_data(GTK_CLIST(history_list), rowindex);
    delete time_ptr;
    gtk_clist_remove(GTK_CLIST(history_list), rowindex);
    node = GTK_CLIST(history_list)->selection;
  }
  pthread_mutex_unlock(history_lock_ptr);
  return TRUE;
}

// history_window򱣤
static gboolean History_cancel(GtkWidget *history_window)
{
  gtk_widget_hide(history_window);
  GtkWidget *history_list = (GtkWidget *)gtk_object_get_user_data(GTK_OBJECT(history_window));
  gtk_clist_unselect_all(GTK_CLIST(history_list));
  return TRUE;
}

static gboolean History_selection_made(GtkWidget *download_list,
				     unsigned int row,
				     unsigned int column,
				     GdkEventButton *event,
				     gpointer data)
{
  static bool enterflag = false;
  unsigned int nearest_selected_row;
  unsigned int i;

  if(enterflag == true || event == NULL) return TRUE;
  pthread_mutex_t *history_lock_ptr = (pthread_mutex_t *)(gtk_object_get_user_data(GTK_OBJECT(download_list)));
  pthread_mutex_lock(history_lock_ptr);
  enterflag = true;

  switch(event->button) {
  case 1:
  case 3:
    if(event->state & GDK_CONTROL_MASK) {
      //Show_download_log(row);
    } else if(event->state & GDK_SHIFT_MASK) {
      nearest_selected_row = Find_nearest_selected_row(download_list, row);
      if(nearest_selected_row < row) {
	for(i = nearest_selected_row+1; i < row; i++) {
	  gtk_clist_select_row(GTK_CLIST(download_list), i, 0);
	}
      } else {
	for(i = row+1; i < nearest_selected_row; i++) {
	  gtk_clist_select_row(GTK_CLIST(download_list), i, 0);
	}
      }
      //Show_download_log(row);
    } else {// with no mask
      gtk_clist_unselect_all(GTK_CLIST(download_list));
      gtk_clist_select_row(GTK_CLIST(download_list), row, 0);
      //Show_download_log(row);
    }
    //Set_sensitive__items_selected();
    break;
  }
  enterflag = false;
  pthread_mutex_unlock(history_lock_ptr);
  return TRUE;
}

static gboolean History_unselection_made(GtkWidget *download_list,
				       unsigned int row,
				       unsigned int column,
				       GdkEventButton *event,
				       gpointer data)
{
  static bool enterflag = false;

  if(enterflag == true || event == NULL) return TRUE;
  pthread_mutex_t *history_lock_ptr = (pthread_mutex_t *)(gtk_object_get_user_data(GTK_OBJECT(download_list)));
  pthread_mutex_lock(history_lock_ptr);
  enterflag = true;
  switch(event->button) {
  case 1:
  case 3:
    if(event->state & (GDK_CONTROL_MASK | GDK_SHIFT_MASK)) {
      GList *node = GTK_CLIST(download_list)->selection;
      if(node == NULL) {
	/*
	unsigned int length = gtk_text_get_length(GTK_TEXT(text));
	gtk_text_set_point(GTK_TEXT (text), length);
	gtk_text_backward_delete(GTK_TEXT (text), length);
	gtk_notebook_set_tab_label_text(GTK_NOTEBOOK(text_notebook),
					item_log_page, _("not selected"));
	*/
	//Set_sensitive__no_item_selected();
      } else {
	gtk_clist_unselect_row(GTK_CLIST(download_list), row, 0);
	//GList *node = GTK_CLIST(download_list)->selection;
	//if(node == NULL) {
	//  Set_sensitive__no_item_selected();
	//}
	//Show_download_log(row);
      }
    } else {
      GList *node = GTK_CLIST(download_list)->selection;
      if(node != NULL) {
	gtk_clist_unselect_all(GTK_CLIST(download_list));
	gtk_clist_select_row(GTK_CLIST(download_list), row, 0);
	//Set_sensitive__items_selected();
	//Show_download_log(row);
      } else {
	//Set_sensitive__no_item_selected();
      }
    }
    break;
  }
  enterflag = false;
  pthread_mutex_unlock(history_lock_ptr);
  return TRUE;
}

HistoryWindow::HistoryWindow(GtkWindow *toplevel = NULL)
{
  char *title[HistoryWindow::COL_TOTAL_H];

  max_history = 100;

  pthread_mutex_init(&history_lock, NULL);
  //URLŽդѤΥκ
  window = gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(window), _("History URL list"));
  gtk_widget_set_usize(GTK_WIDGET(window), 680, 300);
  gtk_signal_connect_object(GTK_OBJECT(window),
			    "delete_event",
			    GTK_SIGNAL_FUNC(History_cancel),
			    GTK_OBJECT(window));

  // CList åȤѥå륹ɥɥ
  GtkWidget *scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
				 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
		     scrolled_window, TRUE, TRUE, 0);
  gtk_widget_show(scrolled_window);  
  
  // CList 롣Ǥ 2 Ȥ
  title[HistoryWindow::COL_FILE_H] = _("File");
  title[HistoryWindow::COL_SIZE_H] = _("Total");
  title[HistoryWindow::COL_DATE_H] = _("Date");
  title[HistoryWindow::COL_URL_H] = _("URL");
  title[HistoryWindow::COL_SAVE_H] = _("Save");
  history_list = gtk_clist_new_with_titles(COL_TOTAL_H, title);
  gtk_widget_set_name(history_list, "clist");

  gtk_object_set_user_data(GTK_OBJECT(window), history_list);
  gtk_object_set_user_data(GTK_OBJECT(history_list), &history_lock);
  gtk_clist_set_column_auto_resize(GTK_CLIST(history_list),
				   COL_URL_H,
				   TRUE);
  gtk_clist_set_selection_mode(GTK_CLIST(history_list), GTK_SELECTION_MULTIPLE);
  
  gtk_signal_connect(GTK_OBJECT(history_list), "select_row",
		     GTK_SIGNAL_FUNC(History_selection_made),
		     NULL);
  gtk_signal_connect(GTK_OBJECT(history_list), "unselect_row",
		     GTK_SIGNAL_FUNC(History_unselection_made),
		     NULL);
  // ˱Ƥդɬפʤɤʤиɤɤʤ :)
  gtk_clist_set_shadow_type(GTK_CLIST(history_list), GTK_SHADOW_ETCHED_OUT);
  gtk_clist_set_column_width(GTK_CLIST(history_list), COL_FILE_H, 300);
  gtk_clist_set_column_width(GTK_CLIST(history_list), COL_SIZE_H, 100);
  gtk_clist_set_column_width(GTK_CLIST(history_list), COL_DATE_H, 180);

  //modified 2001/3/19
  //gtk_clist_set_column_width(GTK_CLIST(history_list), HistoryWindow::COL_URL_H, 400);
  gtk_clist_set_column_auto_resize(GTK_CLIST(history_list),
				   COL_URL_H, TRUE);
  //modified 2001/3/19
  //gtk_clist_set_column_width(GTK_CLIST(history_list), HistoryWindow::COL_SAVE_H, 400);
  gtk_clist_set_column_auto_resize(GTK_CLIST(history_list),
				   COL_SAVE_H, TRUE);

  gtk_clist_set_column_justification(GTK_CLIST(history_list), COL_SIZE_H, GTK_JUSTIFY_RIGHT);
  //gtk_clist_set_column_justification(GTK_CLIST(history_list), HistoryWindow::COL_DATE_H, GTK_JUSTIFY_RIGHT);


  // CList åȤľܥå˲äɽ
  gtk_container_add(GTK_CONTAINER(scrolled_window), history_list);
  gtk_widget_show(history_list);
  gtk_clist_column_titles_passive(GTK_CLIST(history_list));

  //// action area
  GtkWidget *vbox = gtk_vbox_new(FALSE, 5);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->action_area),
		     vbox, FALSE, FALSE, 0);
  gtk_widget_show(vbox);

  {
    GtkWidget *bbox = gtk_hbutton_box_new();
    gtk_button_box_set_layout(GTK_BUTTON_BOX(bbox), GTK_BUTTONBOX_SPREAD);
    gtk_button_box_set_spacing(GTK_BUTTON_BOX(bbox), 5);
    gtk_box_pack_start(GTK_BOX(vbox),
		       bbox, FALSE, FALSE, 0);
    gtk_widget_show(bbox);
    
    // Add button
    GtkWidget *Add_button = gtk_button_new_with_label(_("Paste"));
    gtk_object_set_user_data(GTK_OBJECT(Add_button), window);
    gtk_signal_connect(GTK_OBJECT(Add_button),
		       "clicked",
		       GTK_SIGNAL_FUNC(History_Add),
		       GTK_OBJECT(history_list));
    gtk_box_pack_start(GTK_BOX(bbox),
		       Add_button, TRUE, TRUE, 0);
    gtk_widget_show(Add_button);
    
    // Delete button
    GtkWidget *Delete_button = gtk_button_new_with_label(_("Clear"));
    gtk_signal_connect(GTK_OBJECT(Delete_button),
		       "clicked",
		       GTK_SIGNAL_FUNC(History_delete),
		       GTK_OBJECT(history_list));
    gtk_box_pack_start(GTK_BOX(bbox),
		       Delete_button, TRUE, TRUE, 0);
    gtk_widget_show(Delete_button);

    // Cancel button
    GtkWidget *Cancel_button = gtk_button_new_with_label(_("Close"));
    gtk_signal_connect_object(GTK_OBJECT(Cancel_button),
			      "clicked",
			      GTK_SIGNAL_FUNC(History_cancel),
			      GTK_OBJECT(window));
    gtk_box_pack_start(GTK_BOX(bbox),
		       Cancel_button, TRUE, TRUE, 0);
    gtk_widget_show(Cancel_button);
  }

  //// window property
  gtk_window_set_modal(GTK_WINDOW(window), FALSE);
  // fixed
  //if(toplevel != NULL)
  //  gtk_window_set_transient_for(GTK_WINDOW(window),
  //				 GTK_WINDOW(toplevel));
}

bool HistoryWindow::add_item(ItemCell *itemcell)
{
  time_t time_log = time(NULL);
  return add_item(itemcell->ret_Filename(),
		  itos(itemcell->ret_Size_Current()),
		  time_log,
		  itemcell->ret_URL(),
		  itemcell->ret_Options().ret_Store_Dir());
}

bool HistoryWindow::add_item(const string& file,
			     const string& size,
			     time_t time_log,
			     const string& url,
			     const string& save)
{
  char *clist_item[HistoryWindow::COL_TOTAL_H];
  if(file.empty()) {
    clist_item[HistoryWindow::COL_FILE_H] = strdup(_("<directory>"));
  } else {
    clist_item[HistoryWindow::COL_FILE_H] = strdup(file.c_str());
  }
  clist_item[HistoryWindow::COL_URL_H] = strdup(url.c_str());
  clist_item[HistoryWindow::COL_SAVE_H] = strdup(save.c_str());
  if(size.size() > 3 && size.find(',') == string::npos) {
    clist_item[HistoryWindow::COL_SIZE_H] = strdup(insert_comma(size).c_str());
  } else {
    clist_item[HistoryWindow::COL_SIZE_H] = strdup(size.c_str());
  }
  //struct tm *local_tm = localtime(&time_log);
  
  string time_str = ctime(&time_log);
  time_str.at(time_str.size()-1) = '\0';
  clist_item[HistoryWindow::COL_DATE_H] = strdup(time_str.c_str());
  //printf("%p\n", ctime(&time_log));
  time_t *time_ptr = new time_t;
  *time_ptr = time_log;

  pthread_mutex_lock(&history_lock);
  bool vadj_flag = false;
  float vadj = 0.0;
  GtkAdjustment *adj = NULL;
  if(gtk_clist_row_is_visible(GTK_CLIST(history_list), GTK_CLIST(history_list)->rows-1) == GTK_VISIBILITY_NONE) {
    vadj_flag = true;
    adj = gtk_clist_get_vadjustment(GTK_CLIST(history_list));
    vadj = adj->value;
  }
  int rowindex = gtk_clist_append(GTK_CLIST(history_list), clist_item);
  //GdkColor color = {0, 0, 0};
  //gtk_clist_set_foreground(GTK_CLIST(history_list), rowindex, &color);

  gtk_clist_set_row_data(GTK_CLIST(history_list), rowindex, time_ptr);
  if(GTK_CLIST(history_list)->rows >= max_history) {
    int diff = max_history-GTK_CLIST(history_list)->rows;
    for(int i = 0; i <= diff; ++i) {
      time_t *time_ptr = (time_t *)gtk_clist_get_row_data(GTK_CLIST(history_list), 0);
      delete time_ptr;
      gtk_clist_remove(GTK_CLIST(history_list), 0);
    }
  }
  if(vadj_flag) {
    gtk_adjustment_set_value(adj, vadj);
  }

  delete [] clist_item[HistoryWindow::COL_FILE_H];
  delete [] clist_item[HistoryWindow::COL_URL_H];
  delete [] clist_item[HistoryWindow::COL_SAVE_H];
  delete [] clist_item[HistoryWindow::COL_SIZE_H];
  delete [] clist_item[HistoryWindow::COL_DATE_H];
  pthread_mutex_unlock(&history_lock);
  return true;
}

void HistoryWindow::show()
{
  gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
  gtk_widget_show(window);
  gdk_window_raise(window->window);
}

void HistoryWindow::hide()
{
  gtk_widget_hide(window);
}

bool HistoryWindow::read_from_file(const string& filename)
{
  ifstream infile(filename.c_str(), ios::in);

  if(infile.bad()) return false;
  while(!infile.eof()) {
    string line;
    getline(infile, line, '\n');
    if(line.size()) {
      string file = Token_splitter(line, "\t");
      string size = Token_splitter(line, "\t");
      time_t time_log = stoi(Token_splitter(line, "\t"));
      string url = Token_splitter(line, "\t");
      string save = Token_splitter(line, "\n");
      
      add_item(file, size, time_log, url, save);
    }
  }
  return true;
}

bool HistoryWindow::write_into_file(const string& filename)
{
  ofstream outfile(filename.c_str(), ios::out, 0600);
  if(outfile.bad()) return false;
  pthread_mutex_lock(&history_lock);
  for(int rowindex = 0; rowindex < GTK_CLIST(history_list)->rows; ++rowindex) {
    char *url;
    gtk_clist_get_text(GTK_CLIST(history_list), rowindex, HistoryWindow::COL_URL_H, &url);
    char *size;
    gtk_clist_get_text(GTK_CLIST(history_list), rowindex, HistoryWindow::COL_SIZE_H, &size);
    time_t *time_ptr = (time_t *)gtk_clist_get_row_data(GTK_CLIST(history_list), rowindex);
    
    char *file;
    gtk_clist_get_text(GTK_CLIST(history_list), rowindex, HistoryWindow::COL_FILE_H, &file);
    char *save;
    gtk_clist_get_text(GTK_CLIST(history_list), rowindex, HistoryWindow::COL_SAVE_H, &save);

    outfile << file << '\t' << size << '\t' << *time_ptr << '\t' << url << '\t' << save << '\n';

  }
  pthread_mutex_unlock(&history_lock);

  return true;
}

void HistoryWindow::set_max_history(int max)
{
  if(max > 0 && HistoryWindow::MAX_HISTORY >= max) {
    max_history = max;
  }
}
