//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: HistoryWindow.h,v 1.3 2001/03/09 06:49:09 tujikawa Exp $

#ifndef _HISTORYWINDOW_H_
#define _HISTORYWINDOW_H_
#include <gtk/gtk.h>
#include <string>
#include <fstream>
#include "aria.h"
#include "URLcontainer.h"
#include "ItemManager.h"
#include "PasteWindow.h"

using namespace std;

class HistoryWindow
{
private:
  GtkWidget *window;
  GtkWidget *history_list;
  int max_history;
  pthread_mutex_t history_lock;
public:
  HistoryWindow(GtkWindow *toplevel = NULL);

  bool add_item(ItemCell *itemcell);
  bool add_item(const string& file,
		const string& size,
		time_t time_log,
		const string& url,
		const string& save);

  bool read_from_file(const string& filename);
  bool write_into_file(const string& filename);
  void set_max_history(int max);
  void show();
  void hide();

  enum {
    COL_FILE_H = 0,
    COL_SIZE_H = 1,
    COL_DATE_H = 2,
    COL_URL_H = 3,
    COL_SAVE_H = 4,
    COL_TOTAL_H = 5
  };

  static const int MAX_HISTORY = 300;
  
};
#endif //_HISTORYWINDOW_H_
