//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: gui_file_open_and_save.cc,v 1.6 2001/03/02 04:36:01 tujikawa Exp $

#include "aria.h"
#include "ItemList.h"
#include "AppOption.h"
#include "ThreadManager.h"
#include "ItemCell.h"
#include "FileBrowser.h"

// external functions
extern void Set_sensitive__list_not_empty();
extern gboolean Hide_window(GtkWidget *window, gpointer unused);
extern gboolean Download_delete_all(GtkWidget *w, gpointer data);

// external variables
extern pthread_cond_t itemlistnotempty;
extern pthread_mutex_t itemlistlock;
extern GtkWidget *itemlistwidget;
extern ItemList *itemlist_global;
extern ItemCell *console_item;
extern AppOption *appoption;
extern ThreadManager *thread_manager;
extern Dialog *cdialog;
extern FileBrowser *cfilebrowser;

// global variables
//static bool AfterOpen = false;

static gboolean File_ok_open_Saved_list(GtkWidget *w, GtkWidget *fs);

//
// ߤΥꥹȤ¸
//
static gboolean File_ok_save_list(GtkWidget *w, GtkWidget *fs)
{
  const char *filename;

  cfilebrowser->hide();
  if((filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs))) != NULL) {
    pthread_mutex_lock(&itemlistlock);
    bool retval = itemlist_global->Save_current_list(filename);
    pthread_mutex_unlock(&itemlistlock);

    if(!retval) {
      console_item->Send_message_to_gui(_("couldn't save"), MSG_SYS_ERROR);
    } else {
      console_item->Send_message_to_gui(_("current list saved"), MSG_SYS_INFO);
      // ³ư㤦եɤ߹फɤ
      /*
      if(AfterOpen){
	AfterOpen = false;
	Download_delete_all(w, NULL);
	cfilebrowser->setup(_("Open Saved list"),
			    File_ok_open_Saved_list);
	cfilebrowser->show();
      }
      */
    }
  }
  return TRUE;
}

gboolean File_save_list(GtkWidget *w, gpointer data)
{
  cfilebrowser->setup(_("Save list"),
	       File_ok_save_list);
  cfilebrowser->show();

  return TRUE;
}

//
// ߤΥꥹȤƤ¸뤫ɤҤͤ
//
/*
static gboolean Save_yes(GtkWidget* w, GtkWidget *window)
{
  cdialog->hide();
  cfilebrowser->setup(_("Save list"),
		      File_ok_save_list);
  cfilebrowser->show();

  return TRUE;
}

static gboolean Save_cancel(GtkWidget *w, GtkWidget *window)
{
  cdialog->hide();
  return TRUE;
}

static gboolean Save_no(GtkWidget* w, GtkWidget *window)
{
  cdialog->hide();
  Download_delete_all(w, NULL);

  cfilebrowser->setup(_("Open Saved list"),
		      File_ok_open_Saved_list);
  cfilebrowser->show();
  
  return TRUE;
}

static void Prompt_save_or_not()
{
  cdialog->setup(_("Open saved list"),
		 _("save current list?"),
		 Save_yes,
		 Save_no,
		 Save_cancel);
  cdialog->show();
}
*/
//
// ¸ƤɥꥹȤɤ߹
//
static gboolean File_ok_open_Saved_list(GtkWidget* w, GtkWidget *fs)
{
  const char *filename;

  cfilebrowser->hide();
  if((filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs))) != NULL) {
    bool retval = itemlist_global->Restore_saved_list(filename);
    if(!retval) {
      console_item->Send_message_to_gui(_("Loading saved List faild"), MSG_SYS_ERROR);
    } else {
      console_item->Send_message_to_gui(_("Saved list opened"), MSG_SYS_INFO);
      if(appoption->Whether_use_automatic_start() ||
	 !thread_manager->Is_all_threads_sleeping()) {
	pthread_cond_broadcast(&itemlistnotempty);
      }
    }
    if(GTK_CLIST(itemlistwidget)->rows > 0) {
      Set_sensitive__list_not_empty();
    }
  }
  return TRUE;
}

gboolean File_open_Saved_list(GtkWidget *w, gpointer data)
{
  /*
  // ߤΥƥꥹȤ¸⤷˴
  if(GTK_CLIST(itemlistwidget)->rows) {// if clist contains any items
    // ߤΥꥹȤ¸뤫ɤҤͤ
    AfterOpen = true;
    Prompt_save_or_not();
  } else {
  */
  // AfterOpen = false;
    cfilebrowser->setup(_("Open Saved list"),
			File_ok_open_Saved_list);
    cfilebrowser->show();
    /*
  }
    */
  return TRUE;
}
