//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: gui_file_open_crc.cc,v 1.7 2001/03/02 04:36:01 tujikawa Exp $

#include "aria.h"
#include "ItemList.h"
#include "AppOption.h"
#include "ThreadManager.h"
#include "ItemCell.h"
#include "FileBrowser.h"

// external functions
extern void Set_sensitive__list_not_empty();
extern gboolean Hide_window(GtkWidget *window, gpointer unused);

// external variables
extern pthread_mutex_t itemlistlock;
//extern pthread_mutex_t itemcrclock;
extern unsigned int OK_connection_id, Cancel_connection_id;
extern GtkWidget *itemlistwidget;
extern ItemList *itemlist_global;
extern ItemCell *console_item;
extern AppOption *appoption;
extern ThreadManager *thread_manager;
extern FileBrowser *cfilebrowser;

//
// CRCեɤ߹
//
// CRCե륻쥯󥦥ɥOKܥ򲡤Ȥν
void Open_crc_file(const string& filename)
{
  pthread_mutex_lock(&itemlistlock);
  bool retval = itemlist_global->Read_CRC_from_file(filename);
  pthread_mutex_unlock(&itemlistlock);
  
  if(retval == false) {
    console_item->Send_message_to_gui(_("Error occurd while reading CRC file"), MSG_SYS_ERROR);
  } else {
    console_item->Send_message_to_gui(_("CRC list opened"), MSG_SYS_INFO);
  }
}

static gboolean File_ok_open_CRC_list(GtkWidget *w, GtkWidget *fs)
{
  const char *filename;

  cfilebrowser->hide();
  if((filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs))) != NULL) {
    Open_crc_file(filename);
  }
  return(TRUE);
}

gboolean File_open_CRC_list(GtkWidget *w, gpointer data)
{
  cfilebrowser->setup(_("Open CRC list"),
		      File_ok_open_CRC_list);
  cfilebrowser->show();
  return(TRUE);
}
