//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: gui_main.cc,v 1.26 2001/03/22 08:42:18 tujikawa Exp $

#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "aria.h"
#include "utils.h"
#include "ItemCell.h"
#include "ItemList.h"
#include "ItemManager.h"
#include "ItemStatus.h"
#include "FileBrowser.h"
#include "Dialog.h"
#include "CtrlSocket.h"
#include "PasteWindow.h"
#include "pixmaps/progress_bar.h"
#include "pixmaps/download.xpm"
#include "pixmaps/ready.xpm"
#include "pixmaps/divide.xpm"
#include "pixmaps/complete.xpm"
#include "pixmaps/error.xpm"
#include "pixmaps/stop.xpm"
#include "pixmaps/lock.xpm"
#include "pixmaps/speed.xpm"
#include "aria_mime.h"

extern bool Download_delete_sub(ItemCell *itemcell);
extern gboolean File_quit_c(GtkWidget *w, gboolean (*Signal_Func)(GtkWidget *w, GtkWidget *window));
extern gboolean File_quit(GtkWidget *w, GtkWidget *unused);
extern void Create_file_selection_windows(GtkWidget *w);
extern void Create_file_menu(GtkWidget *toplevel, GtkWidget *menu_bar, GtkAccelGroup *accel_group);
extern void Create_edit_menu(GtkWidget *toplevel, GtkWidget *menu_bar, GtkAccelGroup *accel_group);
extern void Create_download_menu(GtkWidget *menu_bar, GtkAccelGroup *accel_group);
extern void Create_option_menu(GtkWidget *toplevel, GtkWidget *menu_bar, GtkAccelGroup *accel_group);
extern void Create_help_menu(GtkWidget *window, GtkWidget *menu_bar, GtkAccelGroup *accel_group);
extern GtkWidget *Create_toolbar(GtkWidget *toplevel);
extern void Create_popup_menu();
extern void Download_change_speed(float fspeed);

extern void Toolbar_set_sensitive__no_item_selected();
extern void Toolbar_set_sensitive__items_selected();
extern void Toolbar_set_sensitive__list_empty();
extern void Toolbar_set_sensitive__list_not_empty();
extern void Download_set_sensitive__no_item_selected();
extern void Download_set_sensitive__items_selected();
extern void Download_set_sensitive__list_empty();
extern void Download_set_sensitive__list_not_empty();
extern void Option_set_sensitive__no_item_selected();
extern void Option_set_sensitive__items_selected();
extern void Option_set_sensitive__list_empty();
extern void Option_set_sensitive__list_not_empty();
extern void Track_disable();
extern void Setup_dnd(GtkWidget *toplevel, void (*Signal_Func)(GtkWidget  *w,
							       GdkDragContext *context,
							       int x,
							       int y,
							       GtkSelectionData *data,
							       unsigned int info,
							       unsigned int time));
/*
extern void dragged_to_download_list(GtkWidget  *w,
				     GdkDragContext *context,
				     int x,
				     int y,
				     GtkSelectionData *data,
				     unsigned int info,
				     unsigned int time);

*/

extern int pipetogui[2];
extern pthread_mutex_t itemlistlock;
extern pthread_cond_t itemlistnotempty;
extern ItemList *itemlist_global;
extern ItemCell *console_item;
extern ItemManager *item_manager;
extern AppOption *appoption;
extern CtrlSocket ctrlsock;
extern PasteWindow *paste_window;
extern unsigned int thread_limit;
extern GtkWidget *popup_menu;
// global variables
GtkWidget *itemlistwidget, *text, *console_text;
static GtkWidget *speed_scale;
Dialog *cdialog;
FileBrowser *cfilebrowser;

static GtkWidget *item_log_page;
static GtkWidget *text_notebook;
/*
static GdkColor complete_g;
static GdkColor ready_g;
static GdkColor error_g;
static GdkColor stop_g;
static GdkColor download_g;
static GdkColor divide_g;
*/
GdkBitmap *progress_bar_mask[101];
GdkPixmap *progress_bar[101];
/*
GdkBitmap *icon_download_mask;
GdkPixmap *icon_download;
GdkBitmap *icon_ready_mask;
GdkPixmap *icon_ready;
GdkBitmap *icon_error_mask;
GdkPixmap *icon_error;
GdkBitmap *icon_complete_mask;
GdkPixmap *icon_complete;
GdkBitmap *icon_divide_mask;
GdkPixmap *icon_divide;
GdkBitmap *icon_stop_mask;
GdkPixmap *icon_stop;
GdkBitmap *icon_lock_mask;
GdkPixmap *icon_lock;
*/
//GdkPixmap *stat_icon_def[ICON_TOTAL];
//GdkBitmap *stat_iconm_def[ICON_TOTAL];

GdkPixmap *stat_icon[ICON_TOTAL];
GdkBitmap *stat_iconm[ICON_TOTAL];

void Set_sensitive__no_item_selected()
{
  gtk_widget_set_sensitive(speed_scale, FALSE);
  Toolbar_set_sensitive__no_item_selected();
  Download_set_sensitive__no_item_selected();
  Option_set_sensitive__no_item_selected();
}

void Set_sensitive__items_selected()
{
  gtk_widget_set_sensitive(speed_scale, TRUE);
  Toolbar_set_sensitive__items_selected();
  Download_set_sensitive__items_selected();
  Option_set_sensitive__items_selected();
}

void Set_sensitive__list_empty()
{
  Toolbar_set_sensitive__list_empty();
  Download_set_sensitive__list_empty();
  Option_set_sensitive__list_empty();
}

void Set_sensitive__list_not_empty()
{
  Toolbar_set_sensitive__list_not_empty();
  Download_set_sensitive__list_not_empty();
  Option_set_sensitive__list_not_empty();
}

void Set_clist_set_cell_style(int rowindex, GdkColor& color)
{
  /*
  GtkStyle *style;
  style = gtk_style_copy(GTK_WIDGET(itemlistwidget)->style);
  style->fg[GTK_STATE_NORMAL] = color;
  gtk_clist_set_cell_style(GTK_CLIST(itemlistwidget), rowindex, COL_FILENAME, style);
  */
  gtk_clist_set_background(GTK_CLIST(itemlistwidget), rowindex, &color);
}
/*
void Set_clist_column_style__download(int rowindex)
{
  Set_clist_set_cell_style(rowindex, download_g);
}

void Set_clist_column_style__stop(int rowindex)
{
  Set_clist_set_cell_style(rowindex, stop_g);
}

void Set_clist_column_style__error(int rowindex)
{
  Set_clist_set_cell_style(rowindex, error_g);
}

void Set_clist_column_style__complete(int rowindex)
{
  Set_clist_set_cell_style(rowindex, complete_g);
}

void Set_clist_column_style__ready(int rowindex)
{
  Set_clist_set_cell_style(rowindex, ready_g);
}

void Set_clist_column_style__crcerror(int rowindex)
{
  Set_clist_set_cell_style(rowindex, error_g);
}

void Set_clist_column_style__concat(int rowindex)
{
  Set_clist_set_cell_style(rowindex, divide_g);
}

void Set_clist_column_style__divided(int rowindex)
{
  Set_clist_set_cell_style(rowindex, divide_g);
}
*/
void Set_clist_column__crc(int rowindex, const string& crc_string)
{
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_CRC, crc_string.c_str());
}

void Set_clist_column__cursize(int rowindex, const string& size_string)
{
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_CURSIZE, size_string.c_str());
}

void Set_clist_column__totsize(int rowindex, const string& size_string)
{
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_TOTSIZE, size_string.c_str());
}

void Set_clist_column__progress(int rowindex, int progress)
{
  string progress_string = itos(progress);
  // added 2001/3/8
  // start-->
  //progress_bar[progress/2] = gdk_pixmap_ref(progress_bar[progress/2]);
  //progress_bar_mask[progress/2] = gdk_bitmap_ref(progress_bar_mask[progress/2]);
  // <--end
  //GtkCListRow *row = (GtkCListRow *)g_list_nth(GTK_CLIST(itemlistwidget)->row_list, rowindex)->data;
  //if(GTK_CELL_PIXMAP(row->cell[COL_PROGRESS])->pixmap)
  //gdk_pixmap_unref(GTK_CELL_PIXMAP(row->cell[COL_PROGRESS])->pixmap);
  //cerr << "progress: " << progress << endl;
  //cerr << progress/2 << endl;
  gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_PROGRESS, progress_bar[progress/2], progress_bar_mask[progress/2]);
}

void Set_clist_column__filename(int rowindex, const string& filename)
{
  string fix;
  if(filename.empty()) {
    fix = _("<directory>");
  } else {
    fix = filename;
  }
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_FILENAME, fix.c_str());
}

void Set_clist_column__speed(int rowindex, const string& speed_string)
{
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_SPEED, speed_string.c_str());
}

void Set_clist_column__rtime(int rowindex, const string& rtime_string)
{
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_RTIME, rtime_string.c_str());
}

void Set_clist_column__rec(int rowindex, const string& rec_string)
{
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_REC, rec_string.c_str());
}

void Set_clist_column__status(int rowindex, const string& status_string)
{
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, status_string.c_str());
}

void Set_clist_column__icon(int rowindex, ItemCell::ItemStatusType status)
{
  switch(status) {
  case ItemCell::ITEM_READY:
  case ItemCell::ITEM_READY_AGAIN:
  case ItemCell::ITEM_INUSE:
  case ItemCell::ITEM_INUSE_AGAIN:
    //case ITEM_INUSE_CONCAT:
    //icon_ready = gdk_pixmap_ref(icon_ready);// added 2001/3/8
    //icon_ready_mask = gdk_bitmap_ref(icon_ready_mask);

    gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_ICON, stat_icon[ICON_READY], stat_iconm[ICON_READY]);
    gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, _("Ready"));
    break;
  case ItemCell::ITEM_DOWNLOAD_PARTIAL:
    //icon_divide = gdk_pixmap_ref(icon_divide);// added 2001/3/8
    //icon_divide_mask = gdk_bitmap_ref(icon_divide_mask);

    gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_ICON, stat_icon[ICON_DIVIDE], stat_iconm[ICON_DIVIDE]);
    gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, _("DIVIDED"));
    break;

  case ItemCell::ITEM_READY_CONCAT:
  case ItemCell::ITEM_INUSE_CONCAT:
    //icon_divide = gdk_pixmap_ref(icon_divide);// added 2001/3/8
    //icon_divide_mask = gdk_bitmap_ref(icon_divide_mask);

    gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_ICON, stat_icon[ICON_DIVIDE], stat_iconm[ICON_DIVIDE]);
    gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, _("READY TO CONCAT"));
    break;

  case ItemCell::ITEM_CRCERROR:
    //icon_error = gdk_pixmap_ref(icon_error);// added 2001/3/8
    //icon_error_mask = gdk_bitmap_ref(icon_error_mask);

    gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_ICON, stat_icon[ICON_ERROR], stat_iconm[ICON_ERROR]);
    gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, _("CRC ERROR"));
    break;
  case ItemCell::ITEM_EXECERROR:
    //icon_error = gdk_pixmap_ref(icon_error);// added 2001/3/8
    //icon_error_mask = gdk_bitmap_ref(icon_error_mask);

    gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_ICON, stat_icon[ICON_ERROR], stat_iconm[ICON_ERROR]);
    gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, _("EXEC ERROR"));
    break;
  case ItemCell::ITEM_ERROR:
    //icon_error = gdk_pixmap_ref(icon_error);// added 2001/3/8
    //icon_error_mask = gdk_bitmap_ref(icon_error_mask);

    gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_ICON, stat_icon[ICON_ERROR], stat_iconm[ICON_ERROR]);
    gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, _("DOWNLOAD ERROR"));
    break;

  case ItemCell::ITEM_STOP:
    //icon_stop = gdk_pixmap_ref(icon_stop);// added 2001/3/8
    //icon_stop_mask = gdk_bitmap_ref(icon_stop_mask);

    gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_ICON, stat_icon[ICON_STOP], stat_iconm[ICON_STOP]);
    gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, _("STOPPED"));
    break;
  case ItemCell::ITEM_LOCK:
    //icon_lock = gdk_pixmap_ref(icon_lock);// added 2001/3/8
    //icon_lock_mask = gdk_bitmap_ref(icon_lock_mask);

    gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_ICON, stat_icon[ICON_LOCK], stat_iconm[ICON_LOCK]);
    gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, _("LOCKED"));
    break;
  case ItemCell::ITEM_DOWNLOAD:
  case ItemCell::ITEM_DOWNLOAD_AGAIN:
  case ItemCell::ITEM_DOWNLOAD_INTERNAL_AGAIN:
    //icon_download = gdk_pixmap_ref(icon_download);// added 2001/3/8
    //icon_download_mask = gdk_bitmap_ref(icon_download_mask);

    gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_ICON, stat_icon[ICON_DOWNLOAD], stat_iconm[ICON_DOWNLOAD]);
    gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, _("DOWNLOADING"));
    break;

  case ItemCell::ITEM_COMPLETE:
    //icon_complete = gdk_pixmap_ref(icon_complete);// added 2001/3/8
    //icon_complete_mask = gdk_bitmap_ref(icon_complete_mask);

    gtk_clist_set_pixmap(GTK_CLIST(itemlistwidget), rowindex, COL_ICON, stat_icon[ICON_COMPLETE], stat_iconm[ICON_COMPLETE]);
    gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_STATUS, _("DOWNLOAD COMPLETE"));
    break;
  default:
    break;
  }
}

void Set_clist_column__try(int rowindex, const string& try_string)
{
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_RETRY, try_string.c_str());
}

void Set_clist_column__url(int rowindex, const string& url_string)
{
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_URL, url_string.c_str());
}


void Set_clist_column__save(int rowindex, const string& save_string)
{
  gtk_clist_set_text(GTK_CLIST(itemlistwidget), rowindex, COL_SAVE, save_string.c_str());
}

void CTRLSOCK_SEND_LS(int fd, const string& url_str)
{
  if(ctrlsock.Send_command(fd, CmdPacketHeader::CMD_DATA, (void *)url_str.c_str(), url_str.size()+1) < 0) throw 0;
  if(ctrlsock.Recv_command(fd, NULL) < 0) throw 0;
}

void Send_ls_item(int fd, int ls_flag)
{
  pthread_mutex_lock(&itemlistlock);
  try {
    for(int rowindex = 0; rowindex < GTK_CLIST(itemlistwidget)->rows; ++rowindex) {
      ItemCell *itemcell = (ItemCell *)gtk_clist_get_row_data(GTK_CLIST(itemlistwidget), rowindex);
      string url = itemcell->ret_URL();
      //Status (Ready/Error/Downloading/Stop/Complete/Lock)
      //| Split?(Yes/No/split Parts) 
      //|/
      //++-=================================================================
      if(itemcell->Is_Partial()) {
	url = "p "+url;
      } else if(itemcell->ret_Status() == ItemCell::ITEM_DOWNLOAD_PARTIAL) {
	url = "y "+url;
      } else {
	url = "n "+url;
      }
      switch(itemcell->ret_Status()) {
      case ItemCell::ITEM_READY:
      case ItemCell::ITEM_READY_AGAIN:
      case ItemCell::ITEM_READY_CONCAT:
      case ItemCell::ITEM_DOWNLOAD_PARTIAL:
	if(CtrlSocket::CTSOCK_LSREADY & ls_flag) {
	  CTRLSOCK_SEND_LS(fd, 'r'+url);
	}
	break;	
      case ItemCell::ITEM_CRCERROR:
      case ItemCell::ITEM_EXECERROR:
      case ItemCell::ITEM_ERROR:
	if(CtrlSocket::CTSOCK_LSFAILED & ls_flag) {
	  CTRLSOCK_SEND_LS(fd, 'e'+url);
	}
	break;	
      case ItemCell::ITEM_STOP:
	if(CtrlSocket::CTSOCK_LSSTOP & ls_flag) {
	  CTRLSOCK_SEND_LS(fd, 's'+url);
	}
	break;
      case ItemCell::ITEM_DOWNLOAD:
      case ItemCell::ITEM_INUSE:
      case ItemCell::ITEM_INUSE_AGAIN:
      case ItemCell::ITEM_INUSE_CONCAT:
      case ItemCell::ITEM_DOWNLOAD_AGAIN:
      case ItemCell::ITEM_DOWNLOAD_INTERNAL_AGAIN:
	if(CtrlSocket::CTSOCK_LSGO & ls_flag) {
	  CTRLSOCK_SEND_LS(fd, 'd'+url);
	}
	break;
      case ItemCell::ITEM_COMPLETE:
	if(CtrlSocket::CTSOCK_LSCOMP & ls_flag) {
	  CTRLSOCK_SEND_LS(fd, 'c'+url);
	}
	break;
      case ItemCell::ITEM_LOCK:
	if(CtrlSocket::CTSOCK_LSLOCK & ls_flag) {// fixed 2001/3/8
	  CTRLSOCK_SEND_LS(fd, 'l'+url);
	}
	break;
      default:
	if(CtrlSocket::CTSOCK_LSALL == ls_flag) {// fixed 2001/3/8
	  CTRLSOCK_SEND_LS(fd, '?'+url);
	}
	break;	
      }
    }
  } catch(int err) {
  }
  pthread_mutex_unlock(&itemlistlock);
}

// μ
static GdkColor Get_color(MessageType reporttype)
{
  GdkColor color;

  switch(reporttype) {
  case MSG_DOWNLOAD_INFO:
  case MSG_SYS_INFO:
    color.red = 0;
    color.green = 0;
    color.blue = 0;
    break;
  case MSG_DOWNLOAD_SEND:
    //color.red = 0x8888;
    //color.green = 0x8888;
    //color.blue = 0x8888;
    color.red = 14417;
    color.green = 23592;
    color.blue = 19005;
    break;
  case MSG_DOWNLOAD_RECV:
    color.red = 34078;
    color.green = 14417;
    color.blue = 23592;
    break;
  case MSG_SYS_SUCCESS:
  case MSG_DOWNLOAD_SUCCESS:
    color.red = 0;
    color.green = 0;
    color.blue = 0xffff;
    break;
  case MSG_DOWNLOAD_ERROR:
  case MSG_SYS_ERROR:
    color.red = 0xffff;
    color.green = 0;
    color.blue = 0;
    break;
  default:
    color.red = 0;
    color.green = 0;
    color.blue = 0;
  }
  return color;
}

// ƥΥ󥽡̤report_typeˤä̤prefix֤
//  static void TEXT_INSERT_PREFIX(MessageType report_type, GdkColor color)
//  {
//    return;
//    switch(report_type) {
//    case MSG_DOWNLOAD_SEND:
//      gtk_text_insert(GTK_TEXT(text), NULL, &color, NULL, _("SEND: "), -1);
//      break;
//    case MSG_DOWNLOAD_RECV:
//      gtk_text_insert(GTK_TEXT(text), NULL, &color, NULL, _("RECV: "), -1);
//      break;
//    case MSG_DOWNLOAD_INFO:
//      gtk_text_insert(GTK_TEXT(text), NULL, &color, NULL, _("INFO: "), -1);
//      break;
//    case MSG_DOWNLOAD_SUCCESS:
//      gtk_text_insert(GTK_TEXT(text), NULL, &color, NULL, _("SUCC: "), -1);
//      break;
//    case MSG_DOWNLOAD_ERROR:
//      gtk_text_insert(GTK_TEXT(text), NULL, &color, NULL, _("ERR: "), -1);
//      break;
//    default:
//      break;
//    }
//  }

// ˥塼Сκ
static GtkWidget *Create_menu_bar(GtkWidget  *window)
{
  GtkAccelGroup *accel_group;
  GtkWidget *menu_bar;

  menu_bar = gtk_menu_bar_new();
  gtk_menu_bar_set_shadow_type(GTK_MENU_BAR(menu_bar), GTK_SHADOW_ETCHED_OUT);
  gtk_widget_show(menu_bar);

  accel_group = gtk_accel_group_new();
  gtk_accel_group_attach(accel_group, GTK_OBJECT(window));

  Create_file_menu(window, menu_bar, accel_group);
  Create_edit_menu(window, menu_bar, accel_group);
  Create_download_menu(menu_bar, accel_group);
  Create_option_menu(window, menu_bar, accel_group);
  Create_help_menu(window, menu_bar, accel_group);
  return(menu_bar);
}

static void Set_speed_scale(unsigned int rowindex)
{
  ItemCell* itemcell = (ItemCell*)gtk_clist_get_row_data(GTK_CLIST(itemlistwidget), rowindex);
  GtkAdjustment *adj = gtk_range_get_adjustment(GTK_RANGE(speed_scale));
  itemcell->get_Options_Lock();
  adj->value = itemcell->ret_Options_opt().ret_speed_limit();
  itemcell->release_Options_Lock();
  gtk_range_set_adjustment(GTK_RANGE(speed_scale), GTK_ADJUSTMENT(adj));
  gtk_range_clear_background(GTK_RANGE(speed_scale));
  gtk_range_draw_background(GTK_RANGE(speed_scale));

}

static void Show_download_log(unsigned int rowindex)
{
  //static GdkColormap* cmap = gdk_colormap_get_system();
  string line;

  // get data associated to the row
  ItemCell* itemcell = (ItemCell*)gtk_clist_get_row_data(GTK_CLIST(itemlistwidget), rowindex);

  if(itemcell->ret_Filename().empty()) {
    line = _("<directory>");
  } else {
    line = itemcell->ret_Filename();
  }
  gtk_notebook_set_tab_label_text(GTK_NOTEBOOK(text_notebook),
				  item_log_page,
				  line.c_str());

  gtk_text_freeze(GTK_TEXT(text));
  gtk_text_set_point(GTK_TEXT(text), gtk_text_get_length(GTK_TEXT(text)));
  gtk_text_backward_delete(GTK_TEXT(text), gtk_text_get_length(GTK_TEXT(text)));
  gtk_text_set_point(GTK_TEXT(text), gtk_text_get_length(GTK_TEXT(text)));
  gtk_text_thaw(GTK_TEXT(text));

  // acquire lock
  itemcell->get_Log_Lock();
  ItemLogList::const_iterator itemlog_itr;
  gtk_text_freeze(GTK_TEXT(text));
  for(itemlog_itr = itemcell->ret_Log_list().begin(); itemlog_itr != itemcell->ret_Log_list().end(); ++itemlog_itr) {
    GdkColor color = Get_color(itemlog_itr->ret_Logtype());
    gtk_text_insert(GTK_TEXT(text), NULL, &color, NULL, itemlog_itr->ret_Log().c_str(), -1);
    if(itemlog_itr->ret_Log().at(itemlog_itr->ret_Log().size()-1) != '\n') {
      gtk_text_insert(GTK_TEXT(text), NULL, &color, NULL, "\n", -1);
    }
  }
  gtk_text_thaw(GTK_TEXT(text));
  gtk_adjustment_set_value(GTK_TEXT(text)->vadj, GTK_TEXT(text)->vadj->upper+GTK_TEXT(text)->vadj->page_size);
  // release lock
  itemcell->release_Log_Lock();
}

unsigned int Find_nearest_selected_row(GtkWidget *clist, unsigned int row_current)
{
  GList *node = GTK_CLIST(clist)->selection;
  int diff;
  unsigned int rowindex;
  unsigned int row_nearest;
#ifdef DEBUG
  cout << "newest selected row: " << row_current << "\n";
#endif
  rowindex = GPOINTER_TO_UINT(node->data);
#ifdef DEBUG
  cout << "rowindex: " << rowindex << "\n";
#endif
  row_nearest = rowindex;
  node = g_list_next(node);

  while (node)
  {
    rowindex = GPOINTER_TO_UINT(node->data);
    diff = abs(row_current-row_nearest)-abs(row_current-rowindex);
    if(row_current != rowindex &&
       (diff == 0 && row_nearest > rowindex || diff > 0)) {
      row_nearest = rowindex;
    }
    node = g_list_next(node);
  }
#ifdef DEBUG
  cout << "find: " << row_nearest << "\n";
#endif
  return(row_nearest);
}

// 桼ꥹȤιԤ򤹤Ȥˤ
static int unselection_made(GtkWidget      *download_list,
			    int            row,
			    int            column,
			    GdkEventButton *event,
			    gpointer       data )
{
  static bool enterflag = false;

  if(enterflag == true || event == NULL) return TRUE;
  pthread_mutex_lock(&itemlistlock);
  enterflag = true;

  //Track_disable();

  switch(event->button) {
  case 1:
  case 3:
    if(event->state & (GDK_CONTROL_MASK | GDK_SHIFT_MASK)) {
      GList *node = GTK_CLIST(download_list)->selection;
      if(node == NULL) {
	/*
	unsigned int length = gtk_text_get_length(GTK_TEXT(text));
	gtk_text_set_point(GTK_TEXT (text), length);
	gtk_text_backward_delete(GTK_TEXT (text), length);
	gtk_notebook_set_tab_label_text(GTK_NOTEBOOK(text_notebook),
					item_log_page, _("not selected"));
	*/
	Set_sensitive__no_item_selected();
      } else {
	gtk_clist_unselect_row(GTK_CLIST(download_list), row, 0);
	GList *node = GTK_CLIST(download_list)->selection;
	if(node == NULL) {
	  Set_sensitive__no_item_selected();
	}
	//Show_download_log(row);
      }
    } else {
      GList *node = GTK_CLIST(download_list)->selection;
      if(node != NULL) {
	gtk_clist_unselect_all(GTK_CLIST(download_list));
	gtk_clist_select_row(GTK_CLIST(download_list), row, 0);
	Set_sensitive__items_selected();
	Set_speed_scale(row);
	Show_download_log(row);
      } else {
	Set_sensitive__no_item_selected();
      }
    }
    break;
  }
  enterflag = false;
  pthread_mutex_unlock(&itemlistlock);

  return TRUE;
}

// 桼ꥹȤιԤ򤹤Ȥˤ
static int selection_made(GtkWidget      *download_list,
			  unsigned int   row,
			  unsigned int   column,
			  GdkEventButton *event,
			  gpointer       data )
{
  static bool enterflag = false;
  unsigned int nearest_selected_row;
  unsigned int i;

  if(enterflag == true || event == NULL) return TRUE;
  pthread_mutex_lock(&itemlistlock);
  enterflag = true;

  //Track_disable();
  if(event->type == GDK_2BUTTON_PRESS) {
    ItemCell* itemcell = (ItemCell*)gtk_clist_get_row_data(GTK_CLIST(itemlistwidget), row);
    //pthread_mutex_lock(&itemlistlock);
    itemcell->Show_option_window();
    //pthread_mutex_unlock(&itemlistlock);
    Set_sensitive__items_selected();
  } else {
    switch(event->button) {
    case 3:
    case 1:
      if(event->state & GDK_CONTROL_MASK) {
	Set_speed_scale(row);
	Show_download_log(row);
      } else if(event->state & GDK_SHIFT_MASK) {
	nearest_selected_row = Find_nearest_selected_row(download_list, row);
	if(nearest_selected_row < row) {
	  for(i = nearest_selected_row+1; i < row; i++) {
	    gtk_clist_select_row(GTK_CLIST(download_list), i, 0);
	  }
	} else {
	  for(i = row+1; i < nearest_selected_row; i++) {
	    gtk_clist_select_row(GTK_CLIST(download_list), i, 0);
	  }
	}
	Set_speed_scale(row);
	Show_download_log(row);
      } else {// with no mask
	gtk_clist_unselect_all(GTK_CLIST(download_list));
	gtk_clist_select_row(GTK_CLIST(download_list), row, 0);
	Set_speed_scale(row);
	Show_download_log(row);
      }
      Set_sensitive__items_selected();
      break;
    }
  }
  enterflag = false;
  pthread_mutex_unlock(&itemlistlock);

  return(TRUE);
}

// 󥽡ʸlogɲ
void Append_text(const ItemLogCell& itemlogcell, GtkWidget *text)
{
  unsigned int insertionpoint = gtk_text_get_length(GTK_TEXT(text));
  gtk_text_set_point(GTK_TEXT(text), insertionpoint);
  GdkColor color = Get_color(itemlogcell.ret_Logtype());
  bool scroll_to_end = false;
  if(GTK_TEXT(text)->vadj->value+GTK_TEXT(text)->vadj->page_size >= GTK_TEXT(text)->vadj->upper) {
    scroll_to_end = true;
  }
  gtk_text_freeze(GTK_TEXT(text));
  const string& log = itemlogcell.ret_Log();
  gtk_text_insert(GTK_TEXT(text), NULL, &color, NULL, log.c_str(), -1);
  /*
  if(log.at(log.size()-1) != '\n') {
    gtk_text_insert(GTK_TEXT(text), NULL, &color, NULL, "\n", -1);
  }
  */
  gtk_text_thaw (GTK_TEXT (text));
  if(scroll_to_end) {
    gtk_adjustment_set_value(GTK_TEXT(text)->vadj, GTK_TEXT(text)->vadj->upper);
  }
}

// pipetogui[0]˽񤭹ޤ줿ǡɤ߹,GUIȿǤ
static void Update_gui(void *w, int dummy_int, GdkInputCondition dummy_cond)
{
  StatusReport statusreport;
  Socket socket(pipetogui[0], Socket::DUPE);
  //gtk_clist_freeze(GTK_CLIST(itemlistwidget));
  int n_update;
  if(thread_limit > 5) n_update = 5;
  else n_update = thread_limit;

  for(int i = 0; i < n_update; ++i) {
    list<int> fdslist;
    if(socket.is_readready(0, fdslist) > 0) {
      read(pipetogui[0], &statusreport, sizeof(StatusReport));
      ItemStatus *itemstatus = (ItemStatus*)(statusreport.data);
      pthread_mutex_lock(&itemlistlock);
      itemstatus->Update();
      pthread_mutex_unlock(&itemlistlock);
      delete itemstatus;
    } else {
      break;
    }
  }
  //gtk_clist_thaw(GTK_CLIST(itemlistwidget));
}

static GtkWidget *Create_item_log_text()
{
  // text åȤΤȢ
  GtkWidget *vbox=gtk_vbox_new(FALSE, 5);
  gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
  gtk_widget_show(vbox);

  // GtkText åȤ
  // 륦ɥƥȤ˴ϢŤ
  GtkWidget *scrolled_window3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window3),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
  gtk_container_add(GTK_CONTAINER(vbox), scrolled_window3);
  gtk_widget_show(scrolled_window3);

  text = gtk_text_new (NULL, NULL);
  // ƥϤԲĤˤ
  gtk_text_set_editable (GTK_TEXT (text), FALSE);
  gtk_text_set_line_wrap(GTK_TEXT (text), TRUE);
  gtk_text_set_word_wrap(GTK_TEXT (text), TRUE);
  // track text viewpoint
  //gtk_text_set_adjustments(GTK_TEXT(text), NULL, NULL);
  // ƥȥåȤɽ
  gtk_container_add(GTK_CONTAINER(scrolled_window3), text);
  gtk_widget_show (text);

  return(vbox);
}

static GtkWidget *Create_console_log_text()
{
  // text box for console message
  GtkWidget *vbox=gtk_vbox_new(FALSE, 5);
  gtk_widget_show(vbox);
  gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);


  // GtkText åȤ
  // 륦ɥƥȤ˴ϢŤ
  GtkWidget *scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolled_window);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (scrolled_window),
				 GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
  gtk_container_add(GTK_CONTAINER(vbox), scrolled_window);


  console_text = gtk_text_new (NULL, NULL);
  // ƥȥåȤɽ
  gtk_widget_show (console_text);
  // ƥϤԲĤˤ
  gtk_text_set_editable(GTK_TEXT (console_text), FALSE);
  gtk_text_set_line_wrap(GTK_TEXT (console_text), TRUE);
  gtk_text_set_word_wrap(GTK_TEXT (console_text), TRUE);
  // track text viewpoint
  gtk_text_set_adjustments(GTK_TEXT(console_text), NULL, NULL);
  // attach to scrolled window
  gtk_container_add(GTK_CONTAINER(scrolled_window), console_text);

  return(vbox);
}

static GtkWidget *Create_text_notebook()
{
  // create notebook and add 2 pages to it
  text_notebook = gtk_notebook_new();
  gtk_widget_set_usize(text_notebook, 600, 150);
  gtk_notebook_set_tab_pos(GTK_NOTEBOOK(text_notebook), GTK_POS_BOTTOM);
  gtk_notebook_set_show_border(GTK_NOTEBOOK(text_notebook), true);
  gtk_widget_show(text_notebook);

  // 1st page
  GtkWidget *tab1_label = gtk_label_new(_("Console"));
  gtk_notebook_append_page(GTK_NOTEBOOK(text_notebook),
			   Create_console_log_text(),
			   tab1_label);
  // 2nd page
  //item_log_page = Create_item_log_text();
  GtkWidget *tab2_label = gtk_label_new(_("not selected"));
  gtk_notebook_append_page(GTK_NOTEBOOK(text_notebook),
			   (item_log_page = Create_item_log_text()),
			   tab2_label);
  return(text_notebook);
}

static gboolean Row_moved(GtkCList *clist, int src_row, int dst_row, gpointer data)
{
  // at this time, the row doesn't move yet.
  ItemCell *itemcell = (ItemCell *)gtk_clist_get_row_data(clist, src_row);

  item_manager->move_to(dst_row, itemcell);
  if(gtk_clist_row_is_visible(GTK_CLIST(itemlistwidget), dst_row) != GTK_VISIBILITY_FULL) {
    gtk_clist_moveto(GTK_CLIST(itemlistwidget), dst_row, 0, 0.0, 0.0);
  }
  return TRUE;
}

static void dragged_to_download_list(GtkWidget  *w,
			      GdkDragContext *context,
			      int x,
			      int y,
			      GtkSelectionData *data,
			      unsigned int info,
			      unsigned int time)
{
  /*
  switch(info) {
  case MIME_URL:
    cerr << "MIME URL" << endl;
    break;
  case MIME_TEXT_PLAIN:
    cerr << "TEXT PLAIN" << endl;
    break;
  case MIME_TEXT_HTML:
    cerr << "TEXT HTML" << endl;
    break;
  default:
    cerr << "other" << endl;
    break;;
  }
  */
  // cerr << "in guimain" << (char*)data->data << endl;

  if(paste_window->add_url((char *)data->data, info)) {
    paste_window->show();
  }
}
/*
int row;

static gboolean right_click_cb(GtkWidget *widget, 
			       GdkEvent *event,
			       gpointer data) 
{ 
  if (event->button.button == 3) 
    { 
      row = -1;
      int column;
      gtk_clist_get_selection_info(GTK_CLIST(widget),
				   (int)event->button.x, (int)event->button.y,
				   &row, &column);
      if (row > -1) {
	gtk_menu_popup (GTK_MENU (popup_menu), NULL, NULL, 
			NULL, NULL, 3, event->button.time); 
	return TRUE; 
      }
    } 
  return FALSE; 
} 
*/
static GtkWidget *Create_itemlist()
{
  char *titles[TOTALCOL];

  titles[COL_ICON] = _("*");
  titles[COL_FILENAME] = _("File");
  titles[COL_CURSIZE] = _("Downloaded");
  titles[COL_TOTSIZE] = _("Total");
  titles[COL_PROGRESS] = _("%");
  titles[COL_SPEED] = _("Speed");
  titles[COL_RTIME] = _("Remaining");
  titles[COL_RETRY] = _("Retry");
  titles[COL_REC] = _("Recurse");
  titles[COL_STATUS] = _("Status");
  titles[COL_CRC] = "CRC";
  titles[COL_SAVE] = _("Save");
  titles[COL_URL] = "URL";

  // CList åȤѥå륹ɥɥ
  GtkWidget *scrolled_window = gtk_scrolled_window_new (NULL, NULL);

  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (scrolled_window),
				 GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  //create itemlistwidget(CLIST) with 4 columns
  itemlistwidget = gtk_clist_new_with_titles(TOTALCOL, titles);
  //Setup_dnd(itemlistwidget, dragged_to_download_list);


  // resizeability
  gtk_clist_set_column_resizeable(GTK_CLIST(itemlistwidget), COL_PROGRESS, FALSE);
  // 쥯⡼ɤMULTIPLE
  gtk_clist_set_selection_mode(GTK_CLIST(itemlistwidget), GTK_SELECTION_MULTIPLE);


  gtk_clist_set_button_actions(GTK_CLIST(itemlistwidget),
			       2,
			       GTK_BUTTON_SELECTS);

  // dragǤν촹Ĥ
  //gtk_clist_set_reorderable(GTK_CLIST(itemlistwidget), TRUE);
  // ,ΥХå

  gtk_signal_connect(GTK_OBJECT(itemlistwidget), "select_row",
		     GTK_SIGNAL_FUNC(selection_made),
		     NULL);
  gtk_signal_connect(GTK_OBJECT(itemlistwidget), "unselect_row",
		     GTK_SIGNAL_FUNC(unselection_made),
		     NULL);
  gtk_signal_connect(GTK_OBJECT(itemlistwidget), "row-move",
		     GTK_SIGNAL_FUNC(Row_moved),
		     NULL);

  //gtk_signal_connect_after(GTK_OBJECT(itemlistwidget), "button_press_event", 
  //			   GTK_SIGNAL_FUNC(right_click_cb), 
  //			   NULL); 

  // ˱Ƥդ
  gtk_clist_set_shadow_type(GTK_CLIST(itemlistwidget), GTK_SHADOW_ETCHED_OUT);

  gtk_clist_column_titles_passive(GTK_CLIST(itemlistwidget));
  //
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_ICON, 30);
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_FILENAME, 310);
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_CURSIZE, 80);
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_TOTSIZE, 80);
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_PROGRESS, 50);
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_SPEED, 50);
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_RTIME, 70);
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_CRC, 80);
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_STATUS, 150);
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_RETRY, 60);
  gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_REC, 60);
  // modified 2001/3/19
  //gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_SAVE, 400);
  gtk_clist_set_column_auto_resize(GTK_CLIST(itemlistwidget),
				   COL_SAVE, TRUE);
  // modified 2001/3/19
  //gtk_clist_set_column_width(GTK_CLIST(itemlistwidget), COL_URL, 700);
  gtk_clist_set_column_auto_resize(GTK_CLIST(itemlistwidget),
				   COL_URL, TRUE);

  gtk_clist_set_column_justification(GTK_CLIST(itemlistwidget), COL_CURSIZE,
				     GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST(itemlistwidget), COL_TOTSIZE,
				     GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST(itemlistwidget), COL_PROGRESS,
				     GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST(itemlistwidget), COL_SPEED,
				     GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST(itemlistwidget), COL_RETRY,
				     GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST(itemlistwidget), COL_REC,
				     GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST(itemlistwidget), COL_CRC,
				     GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST(itemlistwidget), COL_RTIME,
				     GTK_JUSTIFY_RIGHT);
  gtk_clist_set_row_height(GTK_CLIST(itemlistwidget), 25);

  //associate to scrolled_window
  gtk_container_add(GTK_CONTAINER(scrolled_window), itemlistwidget);

  Setup_dnd(itemlistwidget, dragged_to_download_list);
  gtk_widget_show(itemlistwidget);
  gtk_widget_show(scrolled_window);

  return(scrolled_window);
}

gboolean File_quit_main(GtkWidget *w, gpointer data)
{
  if(appoption->ret_conform_exit()) {
    cdialog->setup(_("Quit program"),
		   _("Are you sure to quit?"),
		   File_quit);
    cdialog->set_cancel_button_visible(false);
    cdialog->show();
  } else {
    File_quit(NULL, NULL);
  }
  return TRUE;
}

static void Create_progress_bar()
{
  char **a[51];

  a[0] = progress0_xpm;

  a[1] = progress1_xpm;
  a[2] = progress2_xpm;
  a[3] = progress3_xpm;
  a[4] = progress4_xpm;
  a[5] = progress5_xpm;
  a[6] = progress6_xpm;
  a[7] = progress7_xpm;
  a[8] = progress8_xpm;
  a[9] = progress9_xpm;
  a[10] = progress10_xpm;
  a[11] = progress11_xpm;
  a[12] = progress12_xpm;
  a[13] = progress13_xpm;
  a[14] = progress14_xpm;
  a[15] = progress15_xpm;
  a[16] = progress16_xpm;
  a[17] = progress17_xpm;
  a[18] = progress18_xpm;
  a[19] = progress19_xpm;
  a[20] = progress20_xpm;
  a[21] = progress21_xpm;
  a[22] = progress22_xpm;
  a[23] = progress23_xpm;
  a[24] = progress24_xpm;
  a[25] = progress25_xpm;
  a[26] = progress26_xpm;
  a[27] = progress27_xpm;
  a[28] = progress28_xpm;
  a[29] = progress29_xpm;
  a[30] = progress30_xpm;
  a[31] = progress31_xpm;
  a[32] = progress32_xpm;
  a[33] = progress33_xpm;
  a[34] = progress34_xpm;
  a[35] = progress35_xpm;
  a[36] = progress36_xpm;
  a[37] = progress37_xpm;
  a[38] = progress38_xpm;
  a[39] = progress39_xpm;
  a[40] = progress40_xpm;
  a[41] = progress41_xpm;
  a[42] = progress42_xpm;
  a[43] = progress43_xpm;
  a[44] = progress44_xpm;
  a[45] = progress45_xpm;
  a[46] = progress46_xpm;
  a[47] = progress47_xpm;
  a[48] = progress48_xpm;
  a[49] = progress49_xpm;
  a[50] = progress50_xpm;

  GtkStyle *style = gtk_widget_get_style(itemlistwidget);
  for(int i = 0; i <= 50; ++i) {
    GdkBitmap *mask;
    progress_bar[i] = gdk_pixmap_create_from_xpm_d(itemlistwidget->window, &mask, &style->bg[GTK_STATE_NORMAL], (char **)a[i]);
    progress_bar_mask[i] = mask;
    //progress_bar[i] = gdk_pixmap_ref(progress_bar[i]);
    //progress_bar_mask[i] = gdk_bitmap_ref(progress_bar_mask[i]);
  }
}

void Create_default_iconset(GdkPixmap **stat_icon, GdkBitmap **stat_iconm)
{
  GtkStyle *style = gtk_widget_get_style(itemlistwidget);

  for(int i = 0; i < ICON_TOTAL; ++i) {
    if(stat_icon[i] != NULL) gdk_pixmap_unref(stat_icon[i]);
    if(stat_iconm[i] != NULL) gdk_bitmap_unref(stat_iconm[i]);
  }
  stat_icon[ICON_DOWNLOAD] = gdk_pixmap_create_from_xpm_d(itemlistwidget->window, &stat_iconm[ICON_DOWNLOAD], &style->bg[GTK_STATE_NORMAL], (char **)download_xpm);
  //gdk_pixmap_ref(stat_icon[ICON_DOWNLOAD]);// added 2001/3/8
  //gdk_bitmap_ref(stat_iconm[ICON_DOWNLOAD]);

  stat_icon[ICON_READY] = gdk_pixmap_create_from_xpm_d(itemlistwidget->window, &stat_iconm[ICON_READY], &style->bg[GTK_STATE_NORMAL], (char **)ready_xpm);
  //gdk_pixmap_ref(stat_icon[ICON_READY]);// added 2001/3/8
  //gdk_bitmap_ref(stat_iconm[ICON_READY]);

  stat_icon[ICON_COMPLETE] = gdk_pixmap_create_from_xpm_d(itemlistwidget->window, &stat_iconm[ICON_COMPLETE], &style->bg[GTK_STATE_NORMAL], (char **)complete_xpm);
  //gdk_pixmap_ref(stat_icon[ICON_COMPLETE]);// added 2001/3/8
  //gdk_bitmap_ref(stat_iconm[ICON_COMPLETE]);

  stat_icon[ICON_STOP] = gdk_pixmap_create_from_xpm_d(itemlistwidget->window, &stat_iconm[ICON_STOP], &style->bg[GTK_STATE_NORMAL], (char **)stop_xpm);
  //gdk_pixmap_ref(stat_icon[ICON_STOP]);// added 2001/3/8
  //gdk_bitmap_ref(stat_iconm[ICON_STOP]);

  stat_icon[ICON_DIVIDE] = gdk_pixmap_create_from_xpm_d(itemlistwidget->window, &stat_iconm[ICON_DIVIDE], &style->bg[GTK_STATE_NORMAL], (char **)divide_xpm);
  //gdk_pixmap_ref(stat_icon[ICON_DIVIDE]);// added 2001/3/8
  //gdk_bitmap_ref(stat_iconm[ICON_DIVIDE]);

  stat_icon[ICON_ERROR] = gdk_pixmap_create_from_xpm_d(itemlistwidget->window, &stat_iconm[ICON_ERROR], &style->bg[GTK_STATE_NORMAL], (char **)error_xpm);
  //gdk_pixmap_ref(stat_icon[ICON_ERROR]);// added 2001/3/8
  //gdk_bitmap_ref(stat_iconm[ICON_ERROR]);

  stat_icon[ICON_LOCK] = gdk_pixmap_create_from_xpm_d(itemlistwidget->window, &stat_iconm[ICON_LOCK], &style->bg[GTK_STATE_NORMAL], (char **)lock_xpm);
  //gdk_pixmap_ref(stat_icon[ICON_LOCK]);// added 2001/3/8
  //gdk_bitmap_ref(stat_iconm[ICON_LOCK]);
}

static gboolean Speed_changed_cb(GtkWidget *w,  GdkEventButton *event,
gpointer data)
{
  GtkAdjustment *adj = gtk_range_get_adjustment(GTK_RANGE(speed_scale));
  Download_change_speed(adj->value);
  return TRUE;
}

GtkWidget *Create_speed_limitter(GtkWidget *toplevel)
{
  GtkWidget *hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hbox);

  GtkWidget *ebox = gtk_event_box_new();
  gtk_widget_show(ebox);
  gtk_box_pack_start(GTK_BOX(hbox), ebox, FALSE, FALSE, 0);

  GtkStyle *style = gtk_widget_get_style(toplevel);
  GdkBitmap *icon_mask;
  GdkPixmap *icon = gdk_pixmap_create_from_xpm_d(toplevel->window, &icon_mask, &style->bg[GTK_STATE_NORMAL], (char **)speed_xpm);
  GtkWidget *pixmap = gtk_pixmap_new(icon, icon_mask);
  gtk_widget_show(pixmap);
  gtk_container_add(GTK_CONTAINER(ebox), pixmap);

  GtkTooltips *tooltip = gtk_tooltips_new();
  gtk_tooltips_enable(tooltip);
  gtk_tooltips_set_tip(tooltip,
		       ebox,
		       _("Limit download speed (in Kbytes/sec) (0.0: unlimited) "),
		       "");
  
  GtkObject *adj= gtk_adjustment_new(0,
				     0,
				     20,
				     0.5,
				     10.0,
				     0);
  speed_scale = gtk_hscale_new(GTK_ADJUSTMENT(adj));
  gtk_scale_set_digits(GTK_SCALE(speed_scale), 1);
  //gtk_range_set_update_policy(GTK_RANGE(speed_scale), GTK_UPDATE_DISCONTINUOUS);

  gtk_scale_set_value_pos(GTK_SCALE(speed_scale), GTK_POS_LEFT);
  gtk_widget_show(speed_scale);
  gtk_widget_set_usize(speed_scale, 300, -1);
  gtk_box_pack_start(GTK_BOX(hbox), speed_scale, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(speed_scale),
		     "button-release-event",
		     GTK_SIGNAL_FUNC(Speed_changed_cb),
		     NULL);
  return hbox;
}

GtkWidget *GUI_main()
{
  GtkWidget *window;
  GtkWidget *vbox;
  GtkWidget *vpaned;

  //ȥåץ٥Υɥκ
  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);

  gtk_widget_set_name(window, "window");
  //set window size
  gtk_widget_set_usize(GTK_WIDGET(window), 750, 450);
  //set window title
  gtk_window_set_title(GTK_WINDOW(window), ARIA_VERSION);

  gtk_signal_connect(GTK_OBJECT(window),
		     "delete_event",
		     GTK_SIGNAL_FUNC(File_quit_main),
		     NULL);
  gtk_widget_realize(window);

  // create vbox widget
  vbox=gtk_vbox_new(FALSE, 5);
  gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
  gtk_container_add(GTK_CONTAINER(window), vbox);
  gtk_widget_show(vbox);
  
  // create menu bar
  gtk_box_pack_start(GTK_BOX(vbox), Create_menu_bar(window), FALSE, TRUE, 0);

  // create tool bar
  GtkWidget *handlebox = gtk_handle_box_new ();
  gtk_widget_show(handlebox);
  gtk_box_pack_start(GTK_BOX(vbox), handlebox, FALSE, TRUE, 0);
  gtk_container_add(GTK_CONTAINER(handlebox), Create_toolbar(window));


  // create speed limitter
  //gtk_box_pack_start(GTK_BOX(vbox), Create_speed_limitter(), FALSE, FALSE, 0);

  // create vpaned widget
  vpaned = gtk_vpaned_new();
  gtk_container_add(GTK_CONTAINER(vbox), vpaned);
  gtk_paned_set_handle_size(GTK_PANED(vpaned), 10);
  gtk_paned_set_gutter_size(GTK_PANED(vpaned), 12);
  gtk_paned_set_position(GTK_PANED(vpaned), 200);
  gtk_widget_show(vpaned);

  // create itemlist
  GtkWidget *lvbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(lvbox);
  gtk_box_pack_start(GTK_BOX(lvbox), Create_speed_limitter(window), FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(lvbox), Create_itemlist(), TRUE, TRUE, 0);
  gtk_paned_add1(GTK_PANED(vpaned), lvbox);
  //gtk_paned_add1(GTK_PANED(vpaned), Create_itemlist());

  // create notebook and add 2 pages to it
  gtk_paned_add2(GTK_PANED(vpaned), Create_text_notebook());

  cdialog = new Dialog(GTK_WINDOW(window));
  cfilebrowser = new FileBrowser(GTK_WINDOW(window));

  // show window

  Create_popup_menu();
  /*
  if(gdk_color_parse("SpringGreen3", &download_g)) {
    gdk_colormap_alloc_color(gdk_colormap_get_system(), &download_g, FALSE, TRUE);
    }
  if(gdk_color_parse("DarkOrange2", &stop_g)) {
    gdk_colormap_alloc_color(gdk_colormap_get_system(), &stop_g, FALSE, TRUE);
  }
  if(gdk_color_parse("red2", &error_g)) {
    gdk_colormap_alloc_color(gdk_colormap_get_system(), &error_g, FALSE, TRUE);
  }
  if(gdk_color_parse("light goldenrod", &complete_g)) {
    gdk_colormap_alloc_color(gdk_colormap_get_system(), &complete_g, FALSE, TRUE);
  }
  if(gdk_color_parse("SkyBlue1", &ready_g)) {
    gdk_colormap_alloc_color(gdk_colormap_get_system(), &ready_g, FALSE, TRUE);
  }
  if(gdk_color_parse("plum2", &divide_g)) {
    gdk_colormap_alloc_color(gdk_colormap_get_system(), &divide_g, FALSE, TRUE);
  }
  */
  gtk_widget_show(window);

  Set_sensitive__no_item_selected();

  Create_progress_bar();
  //Create_icons();
  // watch pipetogui[0] for incoming message
  gdk_input_add(pipetogui[0], GDK_INPUT_READ, Update_gui, NULL);
  return(window);
}
