//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: gui_popup.cc,v 1.5 2001/03/15 05:35:39 tujikawa Exp $

#include <iostream.h>
#include "aria.h"

extern void Download_start(GtkWidget *, gpointer);
extern void Download_stop(GtkWidget *, gpointer);
extern void Download_delete(GtkWidget *, gpointer);
extern void Download_clear_crc(GtkWidget *, gpointer);
extern void Download_download_again(GtkWidget *, gpointer);
GtkWidget *popup_menu;

gboolean Popup_download_again(GtkWidget *w, GdkEvent *event, gpointer data)
{
  if(event->type == GDK_BUTTON_PRESS) {
    Download_download_again(w, data);
    gtk_menu_popdown(GTK_MENU(popup_menu));
    return(TRUE);
  }
  return(FALSE);
}
void Create_popup_menu()
{
  popup_menu = gtk_menu_new();

  GtkWidget *start_item = gtk_menu_item_new_with_label(_("Start"));
  GtkWidget *stop_item = gtk_menu_item_new_with_label(_("Stop"));
  GtkWidget *delete_item = gtk_menu_item_new_with_label(_("Clear"));
  GtkWidget *clear_crc_item = gtk_menu_item_new_with_label(_("Clear CRC"));
  GtkWidget *download_again_item = gtk_menu_item_new_with_label(_("Download again"));

  gtk_menu_append(GTK_MENU(popup_menu), start_item);
  gtk_menu_append(GTK_MENU(popup_menu), stop_item);
  gtk_menu_append(GTK_MENU(popup_menu), delete_item);
  gtk_menu_append(GTK_MENU(popup_menu), clear_crc_item);
  gtk_menu_append(GTK_MENU(popup_menu), download_again_item);

  // signal handling
  gtk_signal_connect_object(GTK_OBJECT(start_item), "activate",
			    GTK_SIGNAL_FUNC(Download_start), NULL);
  gtk_signal_connect_object(GTK_OBJECT(stop_item), "activate",
			    GTK_SIGNAL_FUNC(Download_stop), NULL);
  gtk_signal_connect_object(GTK_OBJECT(delete_item), "activate",
			    GTK_SIGNAL_FUNC(Download_delete), NULL);
  gtk_signal_connect_object(GTK_OBJECT(clear_crc_item), "activate",
			    GTK_SIGNAL_FUNC(Download_clear_crc), NULL);
  gtk_signal_connect_object(GTK_OBJECT(download_again_item), "activate",
			    GTK_SIGNAL_FUNC(Download_download_again), NULL);

  gtk_widget_show(start_item);
  gtk_widget_show(stop_item);
  gtk_widget_show(delete_item);
  gtk_widget_show(clear_crc_item);
  gtk_widget_show(download_again_item);
 
  GtkWidget *popup_item = gtk_menu_item_new_with_label(_("Popup menu"));
  gtk_widget_show(popup_item);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(popup_item), popup_menu);
}
